using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using TAPI;
using Terraria;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace TemplateMod.Items
{
	public class ExampleBreastplate : ModItem
	{
        public int dustDelay = 0;

		public override void ArmorSetBonus(Player p)
		{
			p.setBonus = "Grants many different effects!";
			p.lifeRegen = 10;
			p.breath = p.breathMax;
			//p.maxMinions = 99;
			p.longInvince = true;
			p.accFlipper = true;
			p.iceSkate = true;
			p.manaFlower = true;
			p.slowFall = true;
			p.jumpBoost = true;
			p.doubleJump = true;
			p.doubleJump2 = true;
			p.doubleJump3 = true;
			p.noFallDmg = true;
			p.AddBuff(63, 300, true); //panic necklace effect
			p.statLifeMax2 += 100;
		}

        public override void VanitySetBonus(Player p)
        {
            dustDelay = Math.Max(0, dustDelay - 1);
            if (dustDelay <= 0) //spawn some custom dust
            {
                dustDelay = 3;
                int dustID = Dust.NewDust(p.position, p.width, p.height, 5, p.velocity.X * 0.2f, p.velocity.Y * 0.2f, 100, Color.White, 1.2f);
                Texture2D texture = Main.itemTexture[item.type];
                Main.dust[dustID].OverrideTexture = texture;
                Main.dust[dustID].frame = new Rectangle(0, 0, texture.Width, texture.Height);
                Main.dust[dustID].OverrideUpdate = (dust) =>
                {
                    Color lightColor = Color.Green;
                    lightColor.R = (byte)(lightColor.R * Math.Min(1f, dust.scale));
                    lightColor.G = (byte)(lightColor.G * Math.Min(1f, dust.scale));
                    lightColor.B = (byte)(lightColor.B * Math.Min(1f, dust.scale));
                    Lighting.AddLight(dust.position, (float)lightColor.R / 255f, (float)lightColor.B / 255f, (float)lightColor.B / 255f);
                    dust.rotation += (float)(Math.PI / 16f) * dust.scale;
                    dust.alpha = 200;
                    dust.scale *= 0.965f;
                    dust.velocity *= 0.9f;
                    dust.position += dust.velocity;
                    if (dust.scale <= 0.2f) { dust.active = false; }
                };
            }
        }
	}
}